///////////////////////////////////////////////////////////////////////////////
// FileDatagroupSection.h
// Paul Wilson
// Oxford Metrics, May 2000
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include <vector>

#include "FileSection.h"
#include "FileDatagroupRecord.h"

class VFileDatagroupSection : public VFileSection
{
private:
	std::vector<VFileDatagroupRecord *> m_pRecords;
public:
	VFileDatagroupSection(int a_Len = 0);
	virtual ~VFileDatagroupSection();

	void AddRecord(VFileDatagroupRecord * a_pNewRec) { m_pRecords.push_back(a_pNewRec); }

	virtual SLONG GetDataLength();

	VFileDatagroupRecord * FindDatagroupByID(SSHORT a_TargID);
	const VFileDatagroupRecord * FindDatagroupByID(SSHORT a_TargID) const;

	VFileDatagroupRecord * GetRecordAt(int a_Index);
	const VFileDatagroupRecord * GetRecordAt(int a_Index) const;

	int GetNumRecords() const { return m_pRecords.size(); }

	virtual void PrepareForWrite();
};

