///////////////////////////////////////////////////////////////////////////////
// FileSection.h
// Paul Wilson
// Oxford Metrics, May 2000
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include <string>
#include "Definitions.h"

class VFileSection
{
private:
	std::string m_strName;
	SLONG		m_Length;		// This is the total length INCLUDING the buffer

public:
	VFileSection(SLONG a_Len, std::string a_strName);
	virtual ~VFileSection() = 0;

	std::string GetName() const	{ return m_strName; }
	SLONG GetLength() const{ return m_Length; }

	void SetName(std::string a_strNewName);
	void SetLength(SLONG a_NewLength);

	virtual SLONG GetDataLength() = 0;
	virtual void PrepareForWrite() = 0;
};

