#pragma once

#define COPY_KEYS	"CopyHierarchyKeys"

#include <maya/MPxCommand.h>
#include <maya/MSyntax.h>

#include <string>
#include <vector>

class VCopyKeys : public MPxCommand  
{
public:
	void DisplayError(MString & title, MString & explanation);

	VCopyKeys();
	virtual ~VCopyKeys() {}

	MStatus  doIt(const MArgList& args);
	MStatus  redoIt();
	
	static void * creator();

private:
	bool IsLocatorName(std::string a_strObjectName);
	void FindAllChildLocators(std::string a_strTopNode, std::vector<std::string> & a_rChildLocators);
	void CopySourceKeysToTargets(std::vector< std::vector<std::string> > & a_rChildLocators);
};
