#include "ExtendedFileWrapper.h"
#include "Definitions.h"

VExtendedFileWrapper::VExtendedFileWrapper()
{

}

VExtendedFileWrapper::~VExtendedFileWrapper()
{

}

VExtendedFileWrapper::EFileMode VExtendedFileWrapper::OpenFile(std::string a_strFilename)
{
	assert(a_strFilename != "");
	bool bResult = false;
	EFileMode eMode = EFail;

	// First attempt to open the file as read/write...
	// .. if that fails try read only
	
	if (VThinFileWrapper::OpenFile(a_strFilename.c_str(), "r+b"))
	{
		m_Status = EOpen;
		eMode = EReadWrite;
	}
	else if (VThinFileWrapper::OpenFile(a_strFilename.c_str(), "rb"))
	{
		m_Status = EOpen;
		eMode = EReadOnly;
	}

	return eMode;
}

bool VExtendedFileWrapper::CreateFile(std::string a_strFilename)
{	
	assert(a_strFilename != "");
	bool bRetVal = false;
	
	if (bRetVal = VThinFileWrapper::OpenFile(a_strFilename.c_str(), "w+b"))
		m_Status = ECreate;

	return bRetVal;
}

void VExtendedFileWrapper::CloseFile()
{
	VThinFileWrapper::CloseFile();

	m_Status = EClosed;
}

bool VExtendedFileWrapper::SectionSeek(std::string strSectionName)
{
	bool bRetVal = false;

	// Seek the first section header... it will be immediately after the file header 

	Seek(4, SEEK_SET);

	BYTE Buffer[SECTION_HEADER_SIZE];
	SLONG * pSectionLen = (SLONG *)Buffer;

	do
	{
		// Read the section header

		if ((bRetVal = Read(Buffer, sizeof(Buffer))) == false)
			// Truncated...
			break;

		std::string strCurName = (char *)&Buffer[SECTION_LEN_SIZE];

		if (_stricmp(strCurName.c_str(), strSectionName.c_str()) == 0)
		{
			// Way-hey we've found it... 

			bRetVal = true;
			break;
		}

		// Hop to next section header

		Seek(*pSectionLen, SEEK_CUR);
	}
	while(*pSectionLen > 0);

	// Reposition the file pointer at the beginning of this section header

	Seek(-SECTION_HEADER_SIZE, SEEK_CUR);

	return bRetVal;
}

